<!-- import { RouterLink, RouterView } from "vue-router";  -->


<template>
	<div class="app">
		<h2>Welcome to the UTU SDK Demo for Vue</h2>
		<div>
			(1) <w3m-core-button></w3m-core-button>
		</div>
		<div style="padding-top: 10px" v-if="!(hasToken && walletAddress)">
			(2) <button type=" button" class="x-utu-btn x-utu-btn-light border-radius" style="cursor: pointer"
				@click="onConnectToUtuClick">
				Connect Utu
			</button>
		</div>
		<div style="padding-top: 10px" v-if="hasToken && walletAddress">
			(2) Connected
			<br />
			Wallet Address (source-uuid): {{ walletAddress }}
			<div style="padding-top: 10px">(3) Give or Show Feedback
			</div>
			<br />
			<ul>
				<li v-for="(offer, index) in OFFERS" :key="offer" class="offer">
					<div style="font-weight: bold">{{ offer.name }}</div>
					<x-utu-root :source-uuid='walletAddress' target-type="provider" :target-uuids='OFFERS[index].id'>
						provider (target-uuid): {{ OFFERS[index].id }}
						<x-utu-recommendation :target-uuid='OFFERS[index].id' style="margin-top: -20px" />
					</x-utu-root>
					<br />

					<x-utu-feedback-form-popup :source-uuid='walletAddress' :target-uuid='OFFERS[index].id'
						transaction-id='anything' />

					<x-utu-feedback-details-popup :target-uuid='OFFERS[index].id' :source-uuid='walletAddress' />
				</li>
			</ul>
		</div>


		<div v-else class="three">Nothing to show until you perform Step 2</div>
	</div>
</template>

<script setup type="module">
import { EthereumClient, w3mConnectors, w3mProvider } from "@web3modal/ethereum";
import { Web3Modal } from "@web3modal/html";
import { configureChains, createConfig } from "@wagmi/core";
import { arbitrum, mainnet, polygon } from "@wagmi/core/chains";
import { addressSignatureVerification } from "@ututrust/web-components";
import { ref } from "vue";
import { ethers } from "ethers";


const chains = [arbitrum, mainnet, polygon];
const projectId = "ed0689b91e26b121d6a6145437c7b857";
const { publicClient } = configureChains(chains, [w3mProvider({ projectId })]);
const overrideApiUrl = process.env.VUE_APP_API_URL;

const hasToken = ref(false);
let walletAddress = ref('');

let getId = (assetIdentifier) => {
	return ethers.utils
		.id(assetIdentifier)
		.slice(0, 40 + 2)
		.toLowerCase();
}

const OFFERS = [
	{
		name: "Paul",
		id: getId("provider_1"),
	},
	{
		name: "Jane",
		id: getId("provider_2"),
	},
	{
		name: "Ali",
		id: getId("provider_3"),
	},
];

const wagmiConfig = createConfig({
	autoConnect: true,
	connectors: w3mConnectors({ projectId, chains }),
	publicClient,
});

const ethereumClient = new EthereumClient(wagmiConfig, chains);
const web3modal = new Web3Modal({ projectId }, ethereumClient);

const initEntity = async (data, offer) => {

	console.log(offer);
	console.log(offer.id);
	console.log(ethers)

	await fetch(overrideApiUrl + "/core-api-v2/entity", {
		method: "POST",
		headers: {
			"Content-Type": "application/json",
			authorization: `Bearer ${data.access_token}`,
		},
		body: JSON.stringify({
			name: offer.id,
			type: "provider",
			ids: {
				uuid: offer.id,
			},
			// image,
		}),
	})
		.then((res) => {
			return res;
		})
		.catch((err) => {
			console.log(err);
		});
};

const triggerUtuIdentityDataSDKEvent = (identifyData) => {
	const event = new CustomEvent("utuIdentityDataReady", {
		detail: identifyData,
	});
	window.dispatchEvent(event);
};

// connect UTU
const onConnectToUtuClick = async () => {
	let authDataResponse = await addressSignatureVerification(overrideApiUrl);

	if (authDataResponse) {
		hasToken.value = true;
	}

	for (let i = 0; i < OFFERS.length; i++) {
		await initEntity(authDataResponse, OFFERS[i]);
	}

	triggerUtuIdentityDataSDKEvent(authDataResponse);
	walletAddress.value = window.ethereum.selectedAddress;
	console.log('walletAddress', walletAddress);
};
</script>

<style scoped>
.app {
	background-color: antiquewhite;
	padding: 20px;
	border: 1px solid blac;
}
</style>
